/*-------------------------------------------------------------------------------------------------
 * Copyright (c) 2012, 2017 IBM Corporation and others.
 * Copyright 2017 Xufei Ning
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompanies this distribution.
 *
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *
 *     Michael Fiedler     - initial API and implementation for Bugzilla adapter
 *     Jad El-khoury       - initial implementation of code generator (https://bugs.eclipse.org/bugs/show_bug.cgi?id=422448)
 *     Matthieu Helleboid  - Support for multiple Service Providers.
 *     Anass Radouani      - Support for multiple Service Providers.
 *     Xufei Ning          - Small modification for the JIRA provider
 *
 * This file is generated by org.eclipse.lyo.oslc4j.codegenerator
 ------------------------------------------------------------------------------------------------*/
 
 package servlet;

import java.net.URISyntaxException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import org.eclipse.lyo.oslc4j.application.OslcWinkApplication;
import org.eclipse.lyo.oslc4j.core.exception.OslcCoreApplicationException;
import org.eclipse.lyo.oslc4j.core.model.OslcConstants;
import org.eclipse.lyo.oslc4j.provider.jena.JenaProvidersRegistry;
import org.eclipse.lyo.oslc4j.provider.json4j.Json4JProvidersRegistry;

import services.TrackedResourceSetService;

public class Application extends OslcWinkApplication {

	private static final Set<Class<?>> RESOURCE_CLASSES = new HashSet<Class<?>>();
	private static final Map<String, Class<?>> RESOURCE_SHAPE_PATH_TO_RESOURCE_CLASS_MAP = new HashMap<String, Class<?>>();

	static {
		try {
            RESOURCE_CLASSES.addAll(JenaProvidersRegistry.getProviders());
            RESOURCE_CLASSES.addAll(Json4JProvidersRegistry.getProviders());
            RESOURCE_CLASSES.add(Class.forName("org.eclipse.lyo.server.oauth.webapp.services.ConsumersService"));
            RESOURCE_CLASSES.add(Class.forName("org.eclipse.lyo.server.oauth.webapp.services.OAuthService"));
			
            // Start of user code Custom Resource Classes
			RESOURCE_CLASSES.add(TrackedResourceSetService.class); // TRS
			// End of user code

		} catch (ClassNotFoundException e) {
			e.printStackTrace();
			System.err.println("Application failed to initialize");
		}
	}

	public Application() throws OslcCoreApplicationException, URISyntaxException {
		super(RESOURCE_CLASSES, OslcConstants.PATH_RESOURCE_SHAPES, RESOURCE_SHAPE_PATH_TO_RESOURCE_CLASS_MAP);
	}
}